karaf-user mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From Jean-Baptiste Onofré ...@nanthrax.net>
Subject Re: Using Shiro 1.4.x in OSGi
Date Fri, 23 Nov 2018 16:59:52 GMT
Hi Steinar,

François and I started to work on Shira, providing a feature and
updating the core code. It's still a work in progress, but it will
provide a better Karaf integration.

Regards
JB

On 23/11/2018 17:08, Steinar Bang wrote:
> I'm in the process of trying to move from my use of Shiro 1.3.1 to
> provide authentication and authorization to a webapp, to Shiro 1.4.x.
> 
> Problems so far:
>  1. shiro-core requires spring-beans in a manifest.mf import-package, in
>     addition to being an extra dependency, spring-beans and its
>     dependencies aren't OSGi bundles, so karaf needs to wrap them
>  2. Classloader issues, because Shiro 1.4.x uses reflection to create
>     classes
> 
> Details can be provided if of interest, but I imaging anyone who's tried
> usign Shiro 1.4.x have quickly encountered the classloader issue...:-)
> 
> I have been pondering how to proceed with this.  Some possible
> approaches:
>  1. Try to satisify all the runtime dependencies that the classes that
>     currently won't load, requires (I'm not sure if this is even
>     possible?)
>  2. Slurp all of shiro-core into my bundle (not a desirable approach,
>     since I would like to have pluggable realms)
>  3. Create a new bundle wrapping shiro-core, and adding a DS component
>     that instantates and exposes a SecurityManager service
>  4. Other...?
> 
> Thanks!
> 
> 
>  Steinar
>  
> 

-- 
Jean-Baptiste Onofré
jbonofre@apache.org
http://blog.nanthrax.net
Talend - http://www.talend.com

Mime
View raw message